> ## Documentation Index
> Fetch the complete documentation index at: https://algolia.com/llms.txt
> Use this file to discover all available pages before exploring further.

# How to install Vue InstantSearch

> Learn how to install Vue InstantSearch from npm and load it as a Vue plugin in your app.

<div className="not-prose algolia-flavor-switcher">
  <div className="afs-dropdown">
    <div className="afs-trigger" role="button" tabIndex="0" aria-haspopup="listbox">
      <span className="afs-current">Vue</span>

      <svg className="afs-chevron lucide lucide-chevron-down" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" strokeWidth="2" strokeLinecap="round" strokeLinejoin="round" aria-hidden="true">
        <path d="m6 9 6 6 6-6" />
      </svg>
    </div>

    <ul className="afs-menu" role="listbox">
      <li role="option" aria-selected="false"><a className="afs-option" href="/doc/guides/building-search-ui/installation/js"><span className="afs-option-name">JavaScript</span><span className="afs-option-lib">InstantSearch.js</span></a></li>
      <li role="option" aria-selected="false"><a className="afs-option" href="/doc/guides/building-search-ui/installation/react"><span className="afs-option-name">React</span><span className="afs-option-lib">React InstantSearch</span></a></li>
      <li role="option" aria-selected="true"><a className="afs-option is-current" href="/doc/guides/building-search-ui/installation/vue"><span className="afs-option-name">Vue</span><span className="afs-option-lib">Vue InstantSearch</span></a></li>
      <li role="option" aria-selected="false"><a className="afs-option" href="/doc/guides/building-search-ui/installation/ios"><span className="afs-option-name">iOS</span><span className="afs-option-lib">InstantSearch iOS</span></a></li>
      <li role="option" aria-selected="false"><a className="afs-option" href="/doc/guides/building-search-ui/installation/android"><span className="afs-option-name">Android</span><span className="afs-option-lib">InstantSearch Android</span></a></li>
      <li role="option" aria-selected="false"><a className="afs-option" href="/doc/guides/building-search-ui/installation/flutter"><span className="afs-option-name">Flutter</span><span className="afs-option-lib">Algolia for Flutter</span></a></li>
    </ul>
  </div>
</div>

Install Vue InstantSearch with a packaging system or with a direct link in your web page.

<AccordionGroup>
  <Accordion title="With a packaging system">
    <Steps>
      <Step title="Install Vue InstantSearch from npm">
        If you have a JavaScript build tool (for example if you've created your project using the Vue command-line tool),
        install Vue InstantSearch from npm:

        ```sh Command line icon=square-terminal theme={"system"}
        npm install algoliasearch vue-instantsearch
        ```
      </Step>

      <Step title="Load the package">
        In your `main js` file, load the package as a Vue plugin:

        <CodeGroup>
          ```js Vue 3 theme={"system"}
          import { createApp } from "vue";
          import App from "./App.vue";
          import InstantSearch from "vue-instantsearch/vue3/es";

          const app = createApp(App);
          app.use(InstantSearch);
          app.mount("#app");
          ```

          ```js Vue 2 theme={"system"}
          import Vue from "vue";
          import App from "./App.vue";
          import InstantSearch from "vue-instantsearch";

          Vue.use(InstantSearch);

          new Vue({
            el: "#app",
            render: (h) => h(App),
          });
          ```
        </CodeGroup>

        This lets you use all the widgets directly in your components.
      </Step>
    </Steps>
  </Accordion>

  <Accordion title="Directly in your page">
    <Steps>
      <Step title="Add the two script tags">
        ```html HTML icon=code-xml theme={"system"}
        <script
          src="https://cdn.jsdelivr.net/npm/algoliasearch@5.56.0/dist/lite/builds/browser.umd.js"
          integrity="sha256-FJAyZG3HT2S1oTZ1r2kwy0SBe/MC5MWzteI2GpIsKG0="
          crossorigin="anonymous"
        ></script>
        ```

        ```html HTML icon=code-xml theme={"system"}
        <!-- For Vue 2 -->
        <script src="https://cdn.jsdelivr.net/npm/vue-instantsearch@4.27.1/vue2/umd/index.js" integrity="sha256-NrrY4D1RJgDSD52z5B6eXLLsJ8no/uHTwWyDuexig1A=" crossorigin="anonymous"></script>
        ```

        ```html HTML icon=code-xml theme={"system"}
        <!-- For Vue 3 -->
        <script src="https://cdn.jsdelivr.net/npm/vue-instantsearch@4.27.1/vue3/umd/index.js" integrity="sha256-VBW4yYZQz89Xq+U9btt6wmtbt4dhfPHyf3CCzceATeI=" crossorigin="anonymous"></script>
        ```
      </Step>

      <Step title="Write your Vue app within your HTML">
        For example in an `#app` div:

        ```vue Vue icon=code theme={"system"}
        <!-- Replace INDEX_NAME with the name of your index. -->
        <ais-instant-search index-name="INDEX_NAME" v-bind:search-client="searchClient">
          <!-- Regular Vue InstantSearch app here -->
        </ais-instant-search>
        ```
      </Step>

      <Step title="Instantiate the plugin and app">
        Add a script tag with the instantiation of the plugin and the app:

        <CodeGroup>
          ```js Vue 3 theme={"system"}
          <script>
            const { liteClient: algoliasearch } = window['algoliasearch/lite'];
            const { createApp } = Vue;

            const app = createApp({
              data() {
                return {
                  // Initialize the search client

                  // Replace ALGOLIA_APPLICATION_ID and ALGOLIA_API_KEY with credentials for your Algolia application.
                  searchClient: algoliasearch(
                    'ALGOLIA_APPLICATION_ID',
                    'ALGOLIA_API_KEY'
                  ),
                };
              },
            });
            app.use(VueInstantSearch);
            app.mount('#app');
          </script>
          ```

          ```js Vue 2 theme={"system"}
          <script>
            const { liteClient: algoliasearch } = window['algoliasearch/lite'];
            Vue.use(VueInstantSearch);

            new Vue({
              el: '#app',
              data: {
                // Initialize the search client

                // Replace ALGOLIA_APPLICATION_ID and ALGOLIA_API_KEY with credentials for your Algolia application.
                searchClient: algoliasearch(
                  'ALGOLIA_APPLICATION_ID',
                  'ALGOLIA_API_KEY',
                ),
              },
            });
          </script>
          ```
        </CodeGroup>
      </Step>
    </Steps>

    [`ais-instant-search`](/doc/api-reference/widgets/instantsearch/vue) is the root Vue InstantSearch component.
    All widgets must be wrapped within it.

    <Note>
      In a production environment, [secure your API keys](/doc/guides/security/security-best-practices#secure-your-api-keys) as environment variables.
    </Note>
  </Accordion>
</AccordionGroup>

## Send click and conversion events

Capturing real-time user interactions as events gives you actionable insights through [click and conversion metrics](/doc/guides/search-analytics/concepts/metrics#click-through-rate),
and they help you increase your customer engagement and conversions.
Events are used to activate Algolia features and products like [NeuralSearch](/doc/guides/ai-relevance/neuralsearch/get-started),
[Dynamic Re-Ranking](/doc/guides/algolia-ai/re-ranking),
[Query Categorization](/doc/guides/algolia-ai/query-categorization),
[Recommend](/doc/guides/algolia-recommend/overview),
and [Personalization](/doc/guides/personalization/classic-personalization/what-is-personalization).

To send click and conversion events when users interact with your search UI, set the [`insights`](/doc/api-reference/widgets/instantsearch/vue#param-insights) option to `true`.

## Optimize your build with tree shaking

Tree shaking can be done with modern build tools. The goal is to have code that's actually used in your built site. In the context of Vue InstantSearch this means not including the widgets that aren't used. You can do this by using the components directly, rather than the `Vue.use(InstantSearch)` call.

In every component you're using InstantSearch widgets, you can import and instantiate them like this:

<CodeGroup>
  ```js Vue 3 theme={"system"}
  import { AisInstantSearch, AisSearchBox } from "vue-instantsearch/vue3/es";

  export default {
    components: {
      AisInstantSearch,
      AisSearchBox,
    },
  };
  ```

  ```js Vue 2 theme={"system"}
  import { AisInstantSearch, AisSearchBox } from "vue-instantsearch";

  export default {
    components: {
      AisInstantSearch,
      AisSearchBox,
    },
  };
  ```
</CodeGroup>

The build tool you're using will then be able to only include the widgets that you're actually using.

## Browser support

Algolia supports the last two versions of the major browsers (Chrome, Edge, Firefox, Safari).

To support [Internet Explorer 11](https://wikipedia.org/wiki/Internet_Explorer_11) you need [polyfills](https://wikipedia.org/wiki/Polyfill_\(programming\)) for:
`Array.prototype.find`, `Array.prototype.includes`, `Promise`, `Object.entries`, and `Object.assign`.

<Note>
  The code samples in this documentation use a JavaScript syntax that isn't natively supported by older browsers like Internet Explorer 11.
  If your site needs to support older browsers, use a tool like [Babel](https://babeljs.io/repl) to make your code work in the browsers you target.
</Note>


> ## Documentation Index
> Fetch the complete documentation index at: https://algolia.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Install React InstantSearch

> Learn how to install React InstantSearch from npm and include it in your React app.

<div className="not-prose algolia-flavor-switcher">
  <div className="afs-dropdown">
    <div className="afs-trigger" role="button" tabIndex="0" aria-haspopup="listbox">
      <span className="afs-current">React</span>

      <svg className="afs-chevron lucide lucide-chevron-down" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" strokeWidth="2" strokeLinecap="round" strokeLinejoin="round" aria-hidden="true">
        <path d="m6 9 6 6 6-6" />
      </svg>
    </div>

    <ul className="afs-menu" role="listbox">
      <li role="option" aria-selected="false"><a className="afs-option" href="/doc/guides/building-search-ui/installation/js"><span className="afs-option-name">JavaScript</span><span className="afs-option-lib">InstantSearch.js</span></a></li>
      <li role="option" aria-selected="true"><a className="afs-option is-current" href="/doc/guides/building-search-ui/installation/react"><span className="afs-option-name">React</span><span className="afs-option-lib">React InstantSearch</span></a></li>
      <li role="option" aria-selected="false"><a className="afs-option" href="/doc/guides/building-search-ui/installation/vue"><span className="afs-option-name">Vue</span><span className="afs-option-lib">Vue InstantSearch</span></a></li>
      <li role="option" aria-selected="false"><a className="afs-option" href="/doc/guides/building-search-ui/installation/ios"><span className="afs-option-name">iOS</span><span className="afs-option-lib">InstantSearch iOS</span></a></li>
      <li role="option" aria-selected="false"><a className="afs-option" href="/doc/guides/building-search-ui/installation/android"><span className="afs-option-name">Android</span><span className="afs-option-lib">InstantSearch Android</span></a></li>
      <li role="option" aria-selected="false"><a className="afs-option" href="/doc/guides/building-search-ui/installation/flutter"><span className="afs-option-name">Flutter</span><span className="afs-option-lib">Algolia for Flutter</span></a></li>
    </ul>
  </div>
</div>

<Note>
  This is the **React InstantSearch v7** documentation.
  If you're upgrading from v6, see the [upgrade guide](/doc/guides/building-search-ui/upgrade-guides/react/#migrate-from-react-instantsearch-v6-to-react-instantsearch-v7).
  If you were using React InstantSearch Hooks,
  this v7 documentation applies—just check for [necessary changes](/doc/guides/building-search-ui/upgrade-guides/react/#migrate-from-react-instantsearch-hooks-to-react-instantsearch-v7).
  To continue using v6, you can find the [archived documentation](https://algolia.com/old-docs/deprecated/instantsearch/react/v6/api-reference/instantsearch/).
</Note>

Install React InstantSearch as an npm package or include it in your app with a CDN link.

React InstantSearch is composed of two separate packages:

* [`react-instantsearch`](https://www.npmjs.com/package/react-instantsearch) which exposes all UI widgets and re-exports all Hooks.
* [`react-instantsearch-core`](https://www.npmjs.com/package/react-instantsearch-core) which only exposes all Hooks. **You only need this package if you're using React InstantSearch with React Native.**

<Note>
  The code examples on this page use the React InstantSearch library with the `algoliasearch/lite` client,
  which is smaller but doesn't support indexing your data.
  To perform indexing operations, import the regular `algoliasearch` client.
</Note>

## Install React InstantSearch as an npm package

If you're using a package manager and a build tool, you can install React InstantSearch from npm.

For the web:

<CodeGroup>
  ```sh npm theme={"system"}
  npm install algoliasearch react-instantsearch
  ```

  ```sh yarn theme={"system"}
  yarn add algoliasearch react-instantsearch
  ```

  ```sh pnpm theme={"system"}
  pnpm add algoliasearch react-instantsearch
  ```
</CodeGroup>

For React Native:

<CodeGroup>
  ```sh npm theme={"system"}
  npm install algoliasearch react-instantsearch-core
  ```

  ```sh yarn theme={"system"}
  yarn add algoliasearch react-instantsearch-core
  ```

  ```sh pnpm theme={"system"}
  pnpm add algoliasearch react-instantsearch-core
  ```
</CodeGroup>

Then in your app, import the module:

```jsx React icon=code theme={"system"}
import { liteClient as algoliasearch } from "algoliasearch/lite";
import React from "react";
import { InstantSearch } from "react-instantsearch";

const appID = "ALGOLIA_APPLICATION_ID";
const apiKey = "ALGOLIA_SEARCH_API_KEY";
const indexName = "INDEX_NAME";

const searchClient = algoliasearch(appID, apiKey);

function App() {
	return (
		<InstantSearch searchClient={searchClient} indexName={indexName}>
		</InstantSearch>
	);
}
```

[`InstantSearch`](/doc/api-reference/widgets/instantsearch/react) is the root React InstantSearch component.
All widgets must be wrapped within it

<Check>
  In a production environment, [secure your API keys](/doc/guides/security/security-best-practices#secure-your-api-keys) as environment variables.
</Check>

## Include React InstantSearch with a CDN

If you don't use a package manager and a build tool,
you can include React InstantSearch directly from the [jsDelivr](https://www.jsdelivr.com) CDN.

```html HTML icon=code-xml theme={"system"}
<script
  src="https://cdn.jsdelivr.net/npm/react-instantsearch@7.39.1/dist/es/index.js"
  integrity="sha256-4rg36Ak9cPDb8fuYVFOAcCxz101mDGxYtI8o48jBiPc="
  crossorigin="anonymous"
></script>
```

```html HTML icon=code-xml theme={"system"}
<script
  src="https://cdn.jsdelivr.net/npm/algoliasearch@5.56.0/dist/lite/builds/browser.umd.js"
  integrity="sha256-FJAyZG3HT2S1oTZ1r2kwy0SBe/MC5MWzteI2GpIsKG0="
  crossorigin="anonymous"
></script>
```

You now have access to the `ReactInstantSearch` object on the global `window` object.

```jsx React icon=code theme={"system"}
const { liteClient: algoliasearch } = window["algoliasearch/lite"];
const { InstantSearch } = ReactInstantSearch;

const appID = "ALGOLIA_APPLICATION_ID";
const apiKey = "ALGOLIA_SEARCH_API_KEY";
const indexName = "INDEX_NAME";

const searchClient = algoliasearch(appID, apiKey);

function App() {
  return (
    <InstantSearch searchClient={searchClient} indexName={indexName}>
      {/* Add widgets here */}
    </InstantSearch>
  );
}
```

[`InstantSearch`](/doc/api-reference/widgets/instantsearch/react) is the root React InstantSearch component.
All widgets must be wrapped within it.

<Info>
  In a production environment, you should [secure your API keys](/doc/guides/security/security-best-practices#secure-your-api-keys) as environment variables.
</Info>

## Send click and conversion events

Capturing real-time user interactions as events gives you actionable insights from [click and conversion metrics](/doc/guides/search-analytics/concepts/metrics#click-through-rate),
and they help you increase your customer engagement and conversions.
Events are used to activate Algolia features and products like [NeuralSearch](/doc/guides/ai-relevance/neuralsearch/get-started),
[Dynamic Re-Ranking](/doc/guides/algolia-ai/re-ranking),
[Query Categorization](/doc/guides/algolia-ai/query-categorization),
[Recommend](/doc/guides/algolia-recommend/overview),
and [Personalization](/doc/guides/personalization/classic-personalization/what-is-personalization).

To send click and conversion events when users interact with your search UI, set the [`insights`](/doc/api-reference/widgets/instantsearch/react#param-insights) option to `true`.

## TypeScript support

These packages ship with TypeScript types:

* `react-instantsearch` (v7)
* `react-instantsearch-core` (v7)

The following packages don't ship with TypeScript types,
but have [DefinitelyTyped](https://github.com/DefinitelyTyped/DefinitelyTyped) definitions you can use:

* `react-instantsearch` (v6)
* `react-instantsearch-core` (v6)
* `react-instantsearch-dom` (v6)
* `react-instantsearch-native` (v6)

<Note>
  If you have issues when using them, [contact the DefinitelyTyped community](https://github.com/DefinitelyTyped/DefinitelyTyped/issues).
</Note>

The `react-instantsearch-dom-maps` package doesn't ship with TypeScript types and doesn't have any DefinitelyTyped definitions.

## Browser support

Algolia supports the last two versions of the major browsers:
Chrome, Edge, Firefox, Safari.

To support [Internet Explorer 11](https://wikipedia.org/wiki/Internet_Explorer_11) you need [polyfills](https://wikipedia.org/wiki/Polyfill_\(programming\)) for:
`Array.prototype.find`, `Array.prototype.includes`, `Promise`, `Object.entries`, and `Object.assign`.

<Note>
  The code samples in this documentation use a JavaScript syntax that isn't natively supported by older browsers like Internet Explorer 11.
  If your site needs to support older browsers, use a tool like [Babel](https://babeljs.io/repl) to make your code work in the browsers you target.
</Note>
